'$INCLUDE: 'qbobject.bi'
'This program demonstrate how to use the UpdateEdit, View.Cont
'EditUp, and EditDown command.

'You may point the cursor to an object or object controller and press F1 for parameters.
DIM SHARED editor1.Lscroll, editor1.Uscroll, editor2.Lscroll, editor2.Uscroll

ON ERROR GOTO errors  'goto errors if error occured

DIM editor1(50) AS STRING

Win 100, 50, 500, 450, 0, "Update Edit Example", 7, 1, 7, 1, 1

EditBox 120, 118, 16, 18, editor1(), editor1id
EditBox 310, 118, 16, 18, editor1(), editor2id

SetAlt "_Edit", 120, 118 - 25, 7, 0, 0, editor1id
SetAlt "_Read Only", 310, 118 - 25, 7, 0, 0, editor2id

Button "PgUp", 140, 410, 190, 440, pgup1id
Button "PgDw", 200, 410, 250, 440, pgdw1id

Button "PgUp", 330, 410, 380, 440, pgup2id
Button "PgDw", 390, 410, 440, 440, pgdw2id



'focus to editor1id
SetFocus editor1id

editor1.Lscroll = 0
editor1.Uscroll = 0
editor2.Lscroll = 0
editor2.Uscroll = 0

DO
 
  'control for editor1id
  IF focus = editor1id AND modified THEN
    UpdateEdit editor1(), 0, editor2id
    modified = 0
    editor2.Lscroll = edit.Lscroll
    editor2.Uscroll = edit.Uscroll
  END IF
 
  Edit.Cont editor1(), editor1id
  IF focus = editor1id THEN editor1.Lscroll = edit.Lscroll: editor1.Uscroll = edit.Uscroll

  View.Cont editor1(), editor2id
  IF focus = editor2id THEN editor2.Lscroll = edit.Lscroll: editor2.Uscroll = edit.Uscroll
 
  IF editor1.Lscroll = 0 THEN
    Button.Disable "Pgup", pgup1id
    IF focus = pgup1id THEN IF Enabled(pgdw1id) THEN SetFocus pgdw1id ELSE SetFocus editor1id
  ELSE
    Button.Enable "Pgup", pgup1id
    IF focus = pgdw1id AND Disabled(pgdw1id) THEN SetFocus pgup1id
  END IF

  IF editor1.Uscroll = 0 THEN
    Button.Disable "Pgdw", pgdw1id
    IF focus = pgdw1id THEN IF Enabled(pgup1id) THEN SetFocus pgup1id ELSE SetFocus editor1id
  ELSE
    Button.Enable "Pgdw", pgdw1id
    IF focus = pgup1id AND Disabled(pgup1id) THEN SetFocus pgdw1id
  END IF

  IF editor2.Lscroll = 0 THEN
    Button.Disable "Pgup", pgup2id
    IF focus = pgdw2id THEN IF Enabled(pgdw2id) THEN SetFocus pgdw2id ELSE SetFocus editor2id
  ELSE
    Button.Enable "Pgup", pgup2id
    IF focus = pgdw2id AND Disabled(pgdw2id) THEN SetFocus pgup2id
  END IF

  IF editor2.Uscroll = 0 THEN
    Button.Disable "Pgdw", pgdw2id
    IF focus = pgdw2id THEN IF Enabled(pgup2id) THEN SetFocus pgup2id ELSE SetFocus editor2id
  ELSE
    Button.Enable "Pgdw", pgdw2id
    IF focus = pgup2id AND Disabled(pgup2id) THEN SetFocus pgdw2id
  END IF
 
 
  IF Button.Cont(pgup1id) THEN
    EditUp 16, editor1(), editor1id
    editor1.Lscroll = edit.Lscroll
    editor1.Uscroll = edit.Uscroll
  END IF
  IF Button.Cont(pgdw1id) THEN
    EditDown 16, editor1(), editor1id
    editor1.Lscroll = edit.Lscroll
    editor1.Uscroll = edit.Uscroll
  END IF
 
  IF Button.Cont(pgup2id) THEN
    ViewUp 16, editor1(), editor2id
    editor2.Lscroll = edit.Lscroll
    editor2.Uscroll = edit.Uscroll
  END IF
  IF Button.Cont(pgdw2id) THEN
    ViewDown 16, editor1(), editor2id
    editor2.Lscroll = edit.Lscroll
    editor2.Uscroll = edit.Uscroll
  END IF

  'Exit when ESC was pressed or window close button was clicked.
  IF Click(2) OR key$ = CHR$(27) OR INKEY$ = CHR$(27) THEN EXIT DO

  'Click ,drag, and alt keys trapping. Must be the last line among all controls.
  GetControl

LOOP
FREEXMS  'frees XMS handles. Extremely important
END

errors:
FREEXMS 'frees XMS handles. Extremely important
ERROR ERR 'show error

