'$DYNAMIC
DEFINT A-Z
DECLARE SUB checknul ()
DECLARE SUB searchstring (strarray() AS STRING, controlid%)
DECLARE SUB keyhelp ()
DECLARE SUB havesearch (strarray() AS STRING, controlid%)
DECLARE SUB about ()
DECLARE SUB filenotexist ()
DECLARE FUNCTION ask4overwrite% ()
DECLARE SUB saveeditor (FILESPEC$)
DECLARE SUB cannotsave ()
DECLARE FUNCTION ask4save% ()
DECLARE SUB mainprog ()
DECLARE FUNCTION filedir$ (fileaction%)
DECLARE FUNCTION setcomma$ (var$)
DECLARE SUB getdirs ()
'$INCLUDE: 'qbobject.bi'
ON ERROR GOTO errors
compile = 0
COLOR 7
PRINT "Free String Space:"; FRE("")
PRINT " Free Array Space:"; FRE(-1)

WaitKey CHR$(13)

DIM SHARED drvs(20) AS STRING
DIM SHARED dir(200) AS STRING
DIM SHARED file(300) AS STRING
DIM SHARED editor(340) AS STRING
DIM SHARED keycontext(50) AS STRING
DIM SHARED lblrow, lblcol, editrow, editcol, peditrow, peditcol, match, whole, phrasets$, ask4over, editorfile$, morethan340, readonly, lblfile, menuchoice, menuid, tl, defdrv$, defdir$, filename$, filenymid, dirs$, dirsid, files$, filesid, exits,  _
exitsid, opens, opensid, editid, exiteditid

DIM SHARED filemask$, gosearchid, scancelid, matchid, wholeid, phraseid

defdir$ = CurrDrv$ + ":\" + CurrDir$
defdrv$ = CurrDrv$ + ":"

SetGridlineFocus 0

mainprog

FREEXMS
ChDrv defdrv$
CHDIR defdir$
CLEAR
END
errors:
FREEXMS
SCREEN 0
ChDrv defdrv$
CHDIR defdir$
ERROR ERR

REM $STATIC
SUB about
	lists(1) = "Close"
	lists(2) = "TEXT EDITOR"
	lists(3) = "(Freeware)"
	lists(4) = "Developed using QB Object"
	ctr1 = MsgBox("About TEXT EDITOR", 7, 5, 0, 7, 3, 1)
END SUB

FUNCTION ask4overwrite
  ask4over = 1
  ask4overwrite = ask4save
  ask4over = 0
END FUNCTION

FUNCTION ask4save
	
	lists(1) = "_Yes"
	lists(2) = "_No"
	lists(3) = "_Cancel"
	IF ask4over = 1 THEN lists(4) = "File already exist. Overwrite?" ELSE lists(4) = "File is not saved. Save it now?"
	ask4save = MsgBox("Save", 7, 5, 0, 7, 3, 3)

END FUNCTION

SUB cannotsave
	lists(1) = "Close"
	lists(2) = "This file cannot be save because it"
	lists(3) = "originally contains more than 340"
	lists(4) = "of lines."
	ctr1 = MsgBox("Save", 7, 5, 0, 7, 3, 1)
END SUB

SUB checknul
  IF phrasets$ = "" THEN
     IF Enabled(gosearchid) THEN Button.Disable "_Search", gosearchid
  ELSE
     IF Disabled(gosearchid) THEN Button.Enable "_Search", gosearchid
  END IF
END SUB

REM $DYNAMIC
FUNCTION filedir$ (fileaction)
STATIC fileindex, filevalue$, readonlyid, closeiconid, peditorfile$, buttnym$
filemask$ = "*.*"
peditorfile$ = editorfile$
HardDrives$ = HardDriveList$(Floppies$)
HardDrives% = LEN(HardDrives$)
Floppies% = LEN(Floppies$)
NumDrives% = HardDrives% + Floppies%

FOR N = 1 TO Floppies%
  drvs(N) = "[ " + MID$(Floppies$, N, 1) + " ]"
NEXT

FOR N = Floppies% + 1 TO HardDrives% + Floppies%
  drvs(N) = "[ " + MID$(HardDrives$, N - Floppies%, 1) + " ]"
NEXT

getdirs

main:
filenymid = 0
dirsid = 0
filesid = 0
exitsid = 0
opensid = 0
readonlyid = 0

SaveControl
IF fileaction = 1 THEN a$ = "Open"
IF fileaction = 2 THEN a$ = "Save"
IF fileaction = 3 THEN a$ = "Save As"

Win2 1 + 75, 1 + 10, 0, 0, 0, a$, 7, 1, 7, 3, 1, 1
TextBox "Filenam_e:", 5, 138 + 45, 420, 28, filenymid

setproperties filesid, 0, 0, 15, 0, 0
ListBox 60 + 45, 75, 19, 35, file(), filesid
SetAlt "_Filename      File Size (Bytes)", 85 + 45, 75 - 21, 7, 0, 4, filesid
Line3 105, 50, 415, 72
Line3 218, 51, 218, 70

setproperties dirsid, 0, 0, 15, 0, 0
ListBox 385 + 40, 75, 13, 12, dir(), dirsid
SetAlt "_Dirs/Drives", 395 + 45, 75 - 21, 7, 0, 4, dirsid
Line3 425, 50, 551, 72

CheckBox "_Read-only file", 380 + 45, 360, 5, readonlyid
IF readonly THEN Check readonlyid

IF fileaction = 1 THEN buttnym$ = "_Open"
IF fileaction = 2 OR fileaction = 3 THEN buttnym$ = "_Save"

Button buttnym$, 395 + 45, 384, 495 + 45, 410, opensid
IF editorfile$ = "" THEN Button.Disable buttnym$, opensid
Button "_Cancel", 395 + 45, 416, 495 + 45, 416 + 26, exitsid

drives$ = "[ " + CurrDrv$ + " ]"
pdrives$ = drives$
filename$ = editorfile$

SetFocus filenymid
filesindex = 0
startdir:
DO
  opens = Button.Cont(opensid)
  exits = Button.Cont(exitsid)
 
  Text.Cont filename$, 100, filenymid
  IF focus = filenymid AND key$ = CHR$(13) AND LEFT$(filename$, 2) = "*." THEN filemask$ = filename$: getdirs: updatelist file(), 1, filesid: key$ = ""
 
  IF (key$ = CHR$(13) AND focus = filenymid) THEN IF filename$ <> "" THEN opens = 1 ELSE SetFocus filenymid
  IF filename$ <> "" THEN Button.Enable buttnym$, opensid ELSE Button.Disable buttnym$, opensid
 
  dirs$ = List.Cont(dir(), BWHITE, BLUE, dirsid)
  IF focus = dirsid AND key$ = lef$ THEN SetFocus filesid
 
  Check.Cont readonly, readonlyid
 
  IF dirs$ <> "" THEN
    IF LEFT$(dirs$, 1) = "[" THEN
      ChDrv MID$(dirs$, 3, 1) + ":"
    ELSE
      CHDIR RTRIM$(dirs$)
    END IF
    getdirs
    updatelist dir(), 1, dirsid
    updatelist file(), 1, filesid
    SetFocus filesid
  END IF
 
  files$ = List.Cont(file(), BWHITE, BLUE, filesid)
  IF RTRIM$(filename$) <> RTRIM$(LEFT$(list.value$, 13)) AND list.value$ <> "" THEN
     filename$ = LEFT$(list.value$, 13): PutChar filename$, filenymid
     IF RIGHT$(RTRIM$(LEFT$(list.value$, 13)), 3) = "ICO" THEN
       icox = winpos(1).x1 + 389
       icoy = winpos(1).y1 + 304
       LINE (icox, icoy)-(icox + 32, icoy + 32), 7, BF
       LoadIcon LEFT$(list.value$, 13), icox, icoy, 0
     END IF
  END IF
 
  IF list.index2 > 0 THEN filesindex = list.index2
  IF focus = filesid AND key$ = rig$ THEN SetFocus dirsid
 
  IF filesindex > 0 THEN filevalue$ = file(filesindex)

  IF (key$ = CHR$(13) AND focus = filesid) OR files$ <> "" THEN filename$ = LEFT$(filevalue$, 13): opens = 1

  IF opens AND (filevalue$ <> "" OR filename$ <> "" OR files$ <> "") THEN
    IF LEFT$(filename$, 2) = "*." THEN filemask$ = filename$: getdirs: updatelist file(), 1, filesid: GOTO startdir
    a$ = LEFT$(filevalue$, 13)
    IF focus = filesid THEN filename$ = a$
    IF files$ <> "" THEN a$ = LEFT$(files$, 13)
    IF filename$ <> "" THEN a$ = RTRIM$(LTRIM$(filename$))
    filedir$ = a$
    EXIT DO
  END IF
  IF INKEY$ = CHR$(27) OR key$ = CHR$(27) OR Click(2) OR exits THEN editorfile$ = peditorfile$: EXIT DO
  GetControl
LOOP
RestoreControl
RestoreScr
key$ = ""
END FUNCTION

REM $STATIC
SUB filenotexist
	lists(1) = "Close"
	lists(2) = "File not found."
	ctr1 = MsgBox("Open", 7, 4, 0, 7, 3, 1)
END SUB

REM $DYNAMIC
SUB getdirs
FOR ctr1 = 1 TO 200
  dir(ctr1) = ""
NEXT
FOR ctr1 = 1 TO 300
  file(ctr1) = ""
NEXT

crdir$ = "\" + CurrDir$ + "\"
IF crdir$ = "\\" THEN crdir$ = "\"
crdrv$ = CurrDrv$ + ":" + crdir$
Found% = DirX%(crdrv$ + "*.*", DIRSONLY, FINDFIRST)
fpointer = 1
DO WHILE Found% <> NOTMOREFOUND AND fpointer <= 200
	 Attr = DTA.Attributes
	 IF Found% = ENTRYFOUND AND (Attr <> 512 AND Attr <> 8704 AND Attr <> 768 AND Attr <> 1536 AND Attr <> 8960 AND Attr <> 1792 AND Attr <> 9728 AND Attr <> 9984 AND DTA.filename <> ".            ") THEN
	   dir(fpointer) = DTA.filename
	   fpointer = fpointer + 1
	 END IF
	 ' Search Next entry
	 Found% = DirX%(crdrv$ + "*.*", DIRSONLY, FINDNEXT)
LOOP
FOR ctr1 = 1 TO 20
  dir(ctr1 + fpointer - 1) = drvs(ctr1)
NEXT

Found% = DirX%(crdrv$ + filemask$, FILESONLY, FINDFIRST)
fpointer = 1
DO WHILE Found% <> NOTMOREFOUND AND fpointer <= 300
	 Attr = DTA.Attributes
	 IF compile THEN Attr = Attr + 18
	 IF Found% = ENTRYFOUND AND Attr <> 4114 AND Attr <> 512 AND Attr <> 8722 AND Attr <> 768 AND Attr <> 1536 AND Attr <> 8960 AND Attr <> 1792 AND Attr <> 9728 AND Attr <> 9984 AND Attr <> 10002 THEN
	   tmps$ = LTRIM$(RTRIM$(STR$(DTA.FileSize)))
	   tmps$ = SPACE$(15 - LEN(tmps$)) + tmps$
	   file(fpointer) = DTA.filename + "  " + setcomma(tmps$)
	   fpointer = fpointer + 1
	 END IF
	 Found% = DirX%(crdrv$ + filemask$, FILESONLY, FINDNEXT)
LOOP
END SUB

REM $STATIC
SUB havesearch (strarray() AS STRING, controlid%)
      IF phrasets$ = "" THEN menuchoice = 2: EXIT SUB
      FOR ctr1 = 1 TO UBOUND(strarray)
	memo(ctr1) = strarray(ctr1)
	strarray(ctr1) = ""
      NEXT
      IF match = 0 AND whole = 0 THEN searched = EditSearch(phrasets$, 0, 0, 2, memo(), controlid)
      IF match = 1 AND whole = 0 THEN searched = EditSearch(phrasets$, 0, 1, 2, memo(), controlid)
      IF match = 0 AND whole = 1 THEN searched = EditSearch(phrasets$, 0, 2, 2, memo(), controlid)
      IF match = 1 AND whole = 1 THEN searched = EditSearch(phrasets$, 0, 3, 2, memo(), controlid)
      IF searched = 0 THEN
	lists(1) = "Close"
	lists(2) = "Match not found."
	ctr1 = MsgBox("Search", 7, 4, 0, 7, 3, 1)
      ELSE
	editrow = edit.row
	editcol = edit.col
	UpdateLabel LTRIM$(STR$(editrow)), lblrow: peditrow = editrow
	UpdateLabel LTRIM$(STR$(editcol)), lblcol: peditcol = editcol
      END IF
      FOR ctr1 = 1 TO UBOUND(strarray)
	strarray(ctr1) = memo(ctr1)
	memo(ctr1) = ""
      NEXT
END SUB

SUB keyhelp
STATIC keyid.home, keyid.end, keysearch, keyid, exitkeyid, pphrasets$, keyphrase$, keysearchid
SaveControl
keycontext(1) = "KEY SUMMARY"
keycontext(3) = "DESCRIPTION                            KEY"
keycontext(4) = STRING$(53, "-")


keycontext(5) = "CURSOR MOVEMENT"
keycontext(7) = "Character left                         LEFT"
keycontext(8) = "Character right                        RIGHT"
keycontext(9) = "Line up                                UP"
keycontext(10) = "Line down                              DOWN"
keycontext(11) = ""

keycontext(12) = "TEXT SCROLLING"
keycontext(13) = ""
keycontext(14) = "Page up                                PGUP"
keycontext(15) = "Page down                              PGDN"
keycontext(16) = ""

keycontext(17) = "DELETING TEXT"
keycontext(18) = ""
keycontext(19) = "Delete character to left of cursor     BKSP"
keycontext(20) = "Delete character at cursor             DEL"
keycontext(21) = "Delete rest of word cursor             F2"
keycontext(22) = ""
keycontext(23) = "OTHER KEYS"
keycontext(24) = ""
keycontext(25) = "Insert blank line below                END ENTER"
keycontext(26) = "Go to the top of the text              CTRL+HOME"
keycontext(27) = "Go to the buttom of the text           CTRL+END"
keycontext(28) = "Go to beginning of the line            HOME"
keycontext(29) = "Go to end of the line                  END"


Win2 1 + 75, 1 + 10, 0, 0, 0, "Key Help", 7, 5, 7, 3, 1, 1

EditBox 101, 57, 20, 53, keycontext(), keyid
Button "_Close", 101, 415, 101 + 80, 445, exitkeyid
Button "_Search", 101 + 82, 415, 101 + 80 + 82, 445, keysearchid

SetFocus keyid
keyid.home = 1
DO
  View.Cont keycontext(), keyid
  IF focus = keyid THEN keyid.home = edit.home: keyid.end = edit.end
 
  keysearch = Button.Cont(keysearchid)
  IF keysearch THEN
searchkey:
     pphrasets$ = phrasets$
     phrasets$ = keyphrase$
     searchstring keycontext(), keyid
     IF phrasets$ <> "" THEN keyphrase$ = phrasets$
     phrasets$ = pphrasets$
     SetFocus keyid
  END IF
  IF key$ = CHR$(0) + CHR$(61) THEN
    IF keyphrase$ = "" THEN
      GOTO searchkey
    ELSE
      pphrasets$ = phrasets$
      phrasets$ = keyphrase$
      havesearch keycontext(), keyid
      phrasets$ = pphrasets$
    END IF
  END IF
  IF key$ = CHR$(27) OR Click(2) OR Button.Cont(exitkeyid) THEN EXIT DO
  GetControl
LOOP
RestoreScr
RestoreControl
END SUB

SUB mainprog
    ScreenOff
    Win 0, 0, 639, 479, 0, "TEXT EDITOR By AMP", WHITE, BLUE, WHITE, 0, 1
   
    Box4 5, 26, 635, 56, WHITE
    Box4 5, 57, 635, 475, 7
   
    ErList
    lists(1) = "_File"
    lists(2) = "_Search"
    lists(3) = "_Help"
   
    Menu 18, 29, 1, 20, 7, BLACK, RED, menuid

    Box3 22, 441, 620, 463, WHITE
    Label "File: Untitled", 25, 444, 1, 1, 7, BLACK, WHITE, lblfile
   
    Font "Row:      Col:", 478, 444, 1, 1, 7, BLACK
    Label "1", 470 + 40, 444, 1, 1, 7, BLUE, 7, lblrow
    Label "1", 470 + 120, 444, 1, 1, 7, BLUE, 7, lblcol

    editid = 0
    setproperties editid, BLACK, BLACK, BWHITE, 0, 4
    EditBox 23, 66, 21, 71, editor(), editid
    screenon
doedit:
    ro$ = ""
    IF readonly THEN ro$ = " - Read only"
    b$ = "Untitled"
    IF editorfile$ <> "" THEN b$ = RTRIM$(editorfile$)
    UpdateLabel "File: " + b$ + ro$, lblfile
   
    SetFocus editid
    DO
      IF readonly THEN View.Cont editor(), editid ELSE Edit.Cont editor(), editid
      IF edit.row <> editorow THEN editrow = edit.row
      IF edit.col <> editocol THEN editcol = edit.col
     
      IF editrow <> peditrow THEN UpdateLabel LTRIM$(STR$(editrow)), lblrow: peditrow = editrow
      IF editcol <> peditcol THEN UpdateLabel LTRIM$(STR$(editcol)), lblcol: peditcol = editcol

      Menu.Cont menuchoice, 3, menuid
      IF menuchoice = 1 THEN
	ErList
	lists(1) = " New"
	lists(2) = " Open ..."
	lists(3) = " Save"
	lists(4) = " Save As ...     "
	lists(5) = "_"
	lists(6) = " Print ..."
	lists(7) = "_"
	lists(8) = " Exit"
	IF modified = 0 THEN lists(3) = "!" + lists(3)
       
	submenu1 = SubMenu(BLACK, CYAN, 7, BWHITE, BLUE, menuid)

	IF submenu1 = 1 THEN
newfile:
	  GOSUB ismodified
		 
	  FOR ctr1 = 1 TO 340
	    editor(ctr1) = ""
	  NEXT
	  UpdateEdit editor(), 1, editid
	  ro$ = ""
	  IF readonly THEN ro$ = " - Read only"
	  UpdateLabel "File: Untitled" + ro$, lblfile
	  UpdateLabel "1", lblrow
	  UpdateLabel "1", lblcol
	 
	  modified = 0
	  editorfile$ = ""
	  readonly = 0
	  morethan340 = 0
	  submenu1 = 0
       
	END IF
	   
	IF submenu1 = 2 THEN
openfile:
	   GOSUB ismodified
	   filechoose$ = filedir$(1)
	   IF filechoose$ = "" THEN GOTO doedit
	   IF NOT Exist(filechoose$) THEN filenotexist: GOTO doedit
	   editorfile$ = filechoose$
	   morethan340 = 0
	   modified = 0
	   FOR ctr1 = 1 TO 340
	     editor(ctr1) = ""
	   NEXT
	   OPEN editorfile$ FOR INPUT AS 1
	   FOR ctr1 = 1 TO 341
	     IF EOF(1) THEN EXIT FOR
	     IF ctr1 = 341 THEN morethan340 = 1: EXIT FOR
	     LINE INPUT #1, editor(ctr1)
	   NEXT
	   CLOSE
	   UpdateEdit editor(), 1, editid
	   ro$ = ""
	   IF readonly THEN ro$ = " - Read only"
	   UpdateLabel "File: " + RTRIM$(editorfile$) + ro$, lblfile
	   submenu1 = 0
	END IF
       
	IF submenu1 = 3 THEN
savefile:
	  IF morethan340 THEN cannotsave: GOTO doedit
	 
	  IF editorfile$ = "" THEN fileact = 2: GOSUB openf
	 
	  editorfile$ = filechoose$
	  saveeditor editorfile$
	  ro$ = ""
	  IF readonly THEN ro$ = " - Read only"
	  UpdateLabel "File: " + RTRIM$(editorfile$) + ro$, lblfile
	  modified = 0
	  submenu1 = 0
	END IF
       
	IF submenu1 = 4 THEN
saveasfile:
	  fileact = 3
	  IF morethan340 THEN cannotsave: GOTO doedit
	  GOSUB openf
	  editorfile$ = filechoose$
	  saveeditor editorfile$
	  ro$ = ""
	  IF readonly THEN ro$ = " - Read only"
	  UpdateLabel "File: " + RTRIM$(editorfile$) + ro$, lblfile
	  modified = 0
	  submenu1 = 0
	END IF
      
	IF submenu1 = 5 THEN
	   FOR ctr = 340 TO 1 STEP -1
	     IF editor(ctr) <> "" THEN EXIT FOR
	   NEXT
	   FOR ctr = 1 TO ctr
	     LPRINT "       "; editor(ctr)
	   NEXT
	END IF
	
	IF submenu1 = 6 THEN
exitedit:
	  submenu1 = 0
	  GOSUB ismodified
	  EXIT DO
	END IF
      END IF
     
      IF menuchoice = 2 THEN
	ErList
	lists(1) = " Find ..."
	lists(2) = " Find Next     F3  "
	submenu2 = SubMenu(BLACK, CYAN, 7, BWHITE, BLUE, menuid + 1)
	IF submenu2 = 2 THEN
	  key$ = CHR$(0) + CHR$(61)
	  IF phrasets$ = "" THEN submenu2 = 1
	END IF
       
	IF submenu2 = 1 THEN searchstring editor(), editid
      END IF
     
      IF key$ = CHR$(0) + CHR$(61) THEN havesearch editor(), editid
     
      IF menuchoice = 3 THEN
	ErList
	lists(1) = " Keys ...     "
	lists(2) = " About"
	submenu3 = SubMenu(BLACK, CYAN, 7, BWHITE, BLUE, menuid + 2)
	IF submenu3 = 1 THEN keyhelp
	IF submenu3 = 2 THEN about
      END IF
     
      IF Click(1) THEN EXIT DO
    
      IF key$ = CHR$(27) THEN SetFocus editid
     
      IF key$ = CHR$(14) THEN key$ = "": GOTO newfile
      IF key$ = CHR$(15) THEN key$ = "": GOTO openfile
      IF key$ = CHR$(19) THEN key$ = "": GOTO savefile
      IF key$ = CHR$(1) THEN key$ = "": GOTO saveasfile
     
      GetControl
    LOOP
    FOR ctr1 = 1 TO 340
      editor(ctr1) = ""
    NEXT
    key$ = ""
    EXIT SUB

ismodified:
	  IF modified THEN
	    saveit = ask4save
	    IF saveit = 1 THEN
	      IF morethan340 THEN cannotsave: GOTO doedit
openf3:
	      withexist = 0
	      peditorfile2$ = editorfile$
	      IF editorfile$ = "" THEN editorfile$ = filedir$(2): withexist = 1
	      IF editorfile$ = "" THEN GOTO doedit
	      IF withexist AND Exist(editorfile$) THEN
		overwrite = ask4overwrite
		IF overwrite = 2 THEN editorfile$ = "": GOTO openf3
		IF overwrite = 3 OR overwrite = 0 THEN editorfile$ = peditorfile2$: GOTO doedit
	      END IF
	      saveeditor editorfile$
	      modified = 0
	    END IF
	    IF saveit = 3 OR saveit = 0 THEN GOTO doedit
	  END IF
	  RETURN

openf:
	    filechoose$ = filedir$(fileact)
	    IF filechoose$ = "" THEN GOTO doedit
	  
	    IF Exist(filechoose$) THEN
	      overwrite = ask4overwrite
	      IF overwrite = 2 THEN GOTO openf
	      IF overwrite = 3 OR overwrite = 0 THEN GOTO doedit
	    END IF
	    RETURN

END SUB

SUB saveeditor (FILESPEC$)
IF FILESPEC$ = "" THEN EXIT SUB
OPEN FILESPEC$ FOR OUTPUT AS 1
FOR ctr1 = 340 TO 1 STEP -1
  IF editor(ctr1) <> "" THEN EXIT FOR
NEXT
FOR ctr1 = 1 TO ctr1
  PRINT #1, editor(ctr1)
NEXT
CLOSE
END SUB

SUB searchstring (strarray() AS STRING, controlid%)
  WaitLBoff
  SaveControl
  Win2 130, 120, 500, 350, 0, "Search string", 7, 1, 7, 3, 1, 1
  TextBox "_Find What:", 5, 240, 165, 29, phraseid

  Line3 141, 199, 490, 199
 
  CheckBox "  _Match Case", 160, 217, 5, matchid
  CheckBox "  _Whole Word", 160, 253, 5, wholeid
  IF match THEN Check matchid
  IF whole THEN Check wholeid
 
  Line3 141, 291, 490, 291
 
  Button "_Search", 235, 302, 235 + 80, 332, gosearchid
  Button "_Cancel", 325, 302, 325 + 80, 332, scancelid
  checknul
startsearch:
  SetFocus phraseid
  DO
    Text.Cont phrasets$, 65, phraseid
    Check.Cont match, matchid
    Check.Cont whole, wholeid
   
    checknul
   
    IF Button.Cont(gosearchid) OR (key$ = CHR$(13) AND focus = phraseid) THEN
      IF phrasets$ = "" THEN GOTO startsearch
      RestoreControl
      RestoreScr
     
      havesearch strarray(), controlid
     
      SetFocus editid
      GOTO restored
    END IF
   
    IF Button.Cont(scancelid) THEN EXIT DO
   
    IF key$ = CHR$(27) OR Click(2) THEN EXIT DO
    GetControl
  LOOP
  RestoreControl
  RestoreScr
restored:
  key$ = ""
END SUB

FUNCTION setcomma$ (var$)
FOR ctr1 = LEN(var$) - 2 TO LEN(var$) - LEN(LTRIM$(var$)) + 2 STEP -3
  a$ = MID$(var$, ctr1, LEN(var$))
  MID$(var$, ctr1, LEN(var$)) = "," + SPACE$(LEN(LTRIM$((var$))))
  var$ = RTRIM$(var$) + a$
NEXT
IF LEN(LTRIM$(var$)) < 4 THEN var$ = " " + var$
setcomma = var$
END FUNCTION

